<template>
  <div class="AvatarBody">
    <h3>{{ t('component.avatar.body') }}</h3>
    <span class="AvatarBody__OptionLabel">
      {{ t('component.avatar.skin') }}
    </span>

    <ColorChooser
      v-model="config.faceColor"
      class="AvatarClothing__OptionColor"
      :preferred="AVATAR_OPTIONS.faceColors"
      allow-custom
    />

    <span class="AvatarBody__OptionLabel">
      {{ t('component.avatar.earSize') }}
    </span>
    <Dropdown
      v-model="config.earSize"
      class="AvatarBody__OptionType"
      :options="AVATAR_OPTIONS.earSizes"
      :option-label="getLabel"
      option-value="value"
    />

    <span class="AvatarBody__OptionLabel">
      {{ t('component.avatar.hairType') }}
    </span>
    <ColorChooser
      v-model="config.hairColor"
      class="AvatarClothing__OptionColor"
      :preferred="AVATAR_OPTIONS.hairColors"
      allow-custom
    />
    <Dropdown
      v-model="config.hairType"
      class="AvatarBody__OptionType"
      :options="AVATAR_OPTIONS.hairTypes"
      :option-label="getLabel"
      option-value="value"
    />

    <span class="AvatarBody__OptionLabel">
      {{ t('component.avatar.eyebrowType') }}
    </span>
    <Dropdown
      v-model="config.eyebrowType"
      class="AvatarBody__OptionType"
      :options="AVATAR_OPTIONS.eyebrowTypes"
      :option-label="getLabel"
      option-value="value"
    />

    <span class="AvatarBody__OptionLabel">
      {{ t('component.avatar.eyeType') }}
    </span>
    <Dropdown
      v-model="config.eyeType"
      class="AvatarBody__OptionType"
      :options="AVATAR_OPTIONS.eyeTypes"
      :option-label="getLabel"
      option-value="value"
    />

    <span class="AvatarBody__OptionLabel">
      {{ t('component.avatar.noseType') }}
    </span>
    <Dropdown
      v-model="config.noseType"
      class="AvatarBody__OptionType"
      :options="AVATAR_OPTIONS.noseTypes"
      :option-label="getLabel"
      option-value="value"
    />

    <span class="AvatarBody__OptionLabel">
      {{ t('component.avatar.mouthType') }}
    </span>
    <Dropdown
      v-model="config.mouthType"
      class="AvatarBody__OptionType"
      :options="AVATAR_OPTIONS.mouthTypes"
      :option-label="getLabel"
      option-value="value"
    />
  </div>
</template>

<script lang="ts" setup>
import { AVATAR_OPTIONS, Option } from '@/components/avatar/AvatarOptions'
import { useI18n } from 'vue-i18n'
import Dropdown from 'primevue/dropdown/Dropdown.vue'
import ColorChooser from '@/components/ColorChooser.vue'
import { AvatarConfig } from '@/api'
import { computed } from 'vue'

const { t } = useI18n()

const props = defineProps<{
  modelValue: AvatarConfig
}>()

const emits = defineEmits<{
  /**
   * Updates configuration
   */
  (e: 'update:modelValue', value: AvatarConfig): void
}>()

const config = computed({
  get: () => props.modelValue,
  set: (value: AvatarConfig) => emits('update:modelValue', value),
})

/**
 * Get translated label
 */
function getLabel<T>(option: Option<T>) {
  return t(option.label)
}
</script>

<style lang="scss" scoped>
@use 'src/style/variables' as v;

.AvatarBody {
  display: grid;
  grid-template-columns: [label] 1fr [color] min-content [type] min-content;
  gap: v.$spacing v.$spacing-2;
  align-items: center;

  &__Option {
    &Label {
      grid-column: label;
    }

    &Color {
      grid-column: color;
    }

    &Type {
      grid-column: type;
    }
  }
}
</style>
